# wx200d.pl - wx200d.rrd config file for wxrrdupdate & wxrrdgraph

# @(#)$Id: wx200d.pl,v 1.7 2004/01/24 23:04:25 twitham Exp $

# Copyright (C) 2002 - 2004 Tim Witham <twitham@surewest.net>

# (see the files README and COPYING for more details)

# This is a sample config file for wxrrdupdate(8) and wxrrdgraph(8).
# See those manual pages for complete details.  Save this as wx200d.pl
# in the same directory as your wx200d.rrd file and edit to set your
# preferences for the rrdtool(1) database and graphs.  See the top of
# the scripts for the full list of options and their current defaults.

# This file must be valid perl; use 'perl -c wx200d.pl' to check it!

# ----------------------------------------------------------------------
# wxrrdupdate(8) configuration; see the man page for full details

#$DEBUG = 1;			# uncomment for analyzing the rrdcreate(1)

$LAST = 1;			# Does your RRD have LAST? (0 for v1.2 RRDs)

# Three example data retention policies are shown here, producing the
# database size shown in MB (megabytes).  Use one or tweak your own.

# The first is the defaults as built into version 1.3.  The second is
# a minimum example similar to version 1.2.  It works great for the
# static graphs but is not recommended if you want to drill in to old
# details.  The final is a large example you should only use if you
# have plenty of disk space, memory and CPU power.

# 91 MB: great zoom for 10 days, 60 days and 5 years + 50 year daily almanac
$DETAIL  = 10;		# All details, 86400 / $STEP points per day  (10)
$MINUTE  = 10;		#   1 minute summary,   1440 points per day  (10)
$FIVEMIN = 60;		#   5 minute summary,    288 points per day  (60)
$QUARTER = 366 *  5;	# 1/4 hour   summary,     96 points per day  (366 * 5)
$HOUR    = 366 *  0;	#     hour   summary,     24 points per day  (0)
$DAY     = 366 * 50;	#     daily  summary,    365 points per year (366 * 50)
$WEEK    = 366 *  0;	#     weekly summary,     52 points per year (0)
$MONTH   = 366 *  0;	#   4-week   summary,     13 points per year (0)

## 1.2 MB: MINIMUM option used by wx200d version 1.2 (with $LAST = 0);
#$LAST    = 0;		# no LAST produces buggy rain Total footnote
#$DETAIL  = 2 / 24;	# All details, 86400 / $STEP points per day
#$MINUTE  = 1;		#   1 minute summary,   1440 points per day
#$FIVEMIN = 0;		#   5 minute summary,    288 points per day
#$QUARTER = 7;		# 1/4 hour   summary,     96 points per day
#$HOUR    = 30;		#     hour   summary,     24 points per day
#$DAY     = 365 * 2;	#     daily  summary,    365 points per year
#$WEEK    = 7 * 52 * 5 + 5 * 7; # weekly summary, 52 points per year
#$MONTH   = 7 * 52 * 20 + 5 * 28; # 4-week summary, 13 points per year

## 335 MB: ONLY IF you have large disk space, memory and CPU to burn!!!!
#$DETAIL  = 60;		# All details, 86400 / $STEP points per day
#$MINUTE  = 90;		#   1 minute summary,   1440 points per day
#$FIVEMIN = 366;	#   5 minute summary,    288 points per day
#$QUARTER = 366 * 10;	# 1/4 hour   summary,     96 points per day
#$HOUR    = 365 * 20;	#     hour   summary,     24 points per day
#$DAY     = 365 * 50;	#     daily  summary,    365 points per year
#$WEEK    = 365 * 50;	#     weekly summary,     52 points per year
#$MONTH   = 365 * 50;	#   4-week   summary,     13 points per year

# ----------------------------------------------------------------------
# wxrrdgraph(8) configuration; see the man page for full details

# Keep this if you prefer metric units:
$temp = 0;			# 0=C, 1=F
$baro = 3;			# 0=in, 1=mm, 2=mb, 3=hpa
$wind = 3;			# 0=mph, 1=knots, 2=m/s, 3=kph
$rain = 0;			# 0=mm, 1=inches

# Remove this if you prefer the metric units above:
$temp = 1;			# 0=C, 1=F
$baro = 0;			# 0=in, 1=mm, 2=mb, 3=hpa
$wind = 0;			# 0=mph, 1=knots, 2=m/s, 3=kph
$rain = 1;			# 0=mm, 1=inches

# Remove this is you want indoor variables shown (less outdoor temp resolution):
$incolor = 0;			# indoor temp/humid color or 0 to suppress

# Remove this if you want vertical black lines where data is *UNKNOWN*
$uncolor = 0;			# unknown color or 0 to suppress

1;				# return true
#------------------------------------------------------------
# if you are not Tim Witham, then FIX or REMOVE the rest:

$press = 0.27;			# local to sea press difference in $baro units

$wx200 = 1;			# use wx200 to update wx200.txt

$years = 6;			# how many years to put on the All page

$title = "Weather @ Tim's House"; # base title for each page

# custom HTML header; %s is replaced by the current page name
$head = qq'<b>$title</b> in Citrus Heights, CA by
<a href="http://wx200d.sourceforge.net/">wx200d</a>: <b>%s</b><br>
<a href="./">Back</a> |
<a href="./wx200.txt">Current Conditions</a> |
<a href="data/info.html">Station Info</a> |
<a href="http://www.wunderground.com/US/CA/Citrus_Heights/'
    . qq'KMHR/KCACITRU2.html">wunderground.com</a> |
<RRD::TIME::NOW "%%c"><p>\n';	# %% becomes % in printf

$head =~ s@Tim@<a href="/~twitham/">$&</a>@; # link my name in the header!

# don't try this if you haven't read README!!
@skip = qw();			# turn on the Any CGI graph
$cgiurl = 'http://localhost/cgi-bin/wxrrdgraph'; # URL of the CGI
$base = 'http://localhost/~twitham/wx200/'; # base URL/ of these graph pages
$path = "/usr/local/share/wx200d/html/"; # absolute path/ to these graph pages

#$debug = 1;			# uncomment for debugging the HTML

1;				# return true
